<?php
declare (strict_types = 1);

namespace app\admin\controller;

use think\Request;
use think\facade\View;
use think\facade\Db;

class Label extends Common
{
    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {
        
        $lst=Db::name('label')->order('id asc')->select();
        View::assign([
            'lst'=>$lst,
        ]);
        return View::fetch('index');
    }

    public function value()
    {
        $data=input('post.');
       
        foreach($data as $k=>$v){
            $label=Db::name('label')->where(['name'=>$k])->update(['value'=>$v]);
        }
        return json(['msg'=>'更新成功','status'=>'success']);
        
    }

    /**
     * 显示创建资源表单页.
     *
     * @return \think\Response
     */

    public function add()
    {
        return View::fetch('add');
    }

    public function create()
    {
    
        
        return View::fetch('add');
        
        
    }

    public function getlabel(Request $request)
    {
        $limit = $request->param('limit')?$request->param('limit'):10;
        $builder = Db::name('label');
        $table =$builder->order('id desc')->paginate(['list_rows'=>$limit])->toArray();
        return json(['code'=>0, 'count'=>$table['total'], 'data'=>$table['data']]);
        
    }

    function hasChinese($text) {
        return preg_match('/[\x{4e00}-\x{9fa5}]/u', $text);
    }
    /**
     * 保存新建的资源
     *
     * @param  \think\Request  $request
     * @return \think\Response
     */
    public function save(Request $request)
    {
        $data=input('post.');

        

        if($data['name'] && ! preg_match('/^[a-zA-Z0-9\-_\/]+$/', $data['name'])) {
            return json(['msg'=>'标签名称只允许字母、数字、横线、斜线组成！','status'=>'fail']);
        }else{
            $label=Db::name('label')->where(['name'=>$data['name']])->find();
            if($label){
                return json(['msg'=>'该自定义标签称已经存在，不能再使用！','status'=>'fail']);
            }else{
                $data['time']=time();
                Db::name('label')->insert($data);
                return json(['msg'=>'添加成功','status'=>'success']);
            }
        }
    }

    /**
     * 显示指定的资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function read($id)
    {
        //
    }

    /**
     * 显示编辑资源表单页.
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function edit($id)
    {
       
        $edit=Db::name('label')->find($id);
        View::assign([
            'edit'=>$edit,
        ]);
        return View::fetch('edit');
    }

    /**
     * 保存更新的资源
     *
     * @param  \think\Request  $request
     * @param  int  $id
     * @return \think\Response
     */
    public function update(Request $request, $id)
    {
        $data=input('post.');

        // 获取数据库中的原始数据
        $originalData = Db::name('label')->where('id', $id)->find();

        // 比较数据是否有变化
        $hasChanges = false;
        foreach ($data as $key => $value) {
            if (isset($originalData[$key]) && $originalData[$key] != $value) {
                $hasChanges = true;
                break;
            }
        }
        
        if (!$hasChanges) {
            return json(['status' => 'fail', 'msg' => '没有做任何修改']);
        }
        
        if($data['name'] && ! preg_match('/^[a-zA-Z0-9\-_\/]+$/', $data['name'])) {
            return json(['msg'=>'标签名称只允许字母、数字、横线、斜线组成！','status'=>'fail']);
        }else{
            $label=Db::name('label')->where(['name'=>$data['name']])->find();
            if($label){
                if($label['id']==$data['id']){
                    $label=Db::name('label')->where(['id'=>$data['id']])->save($data);
                    if($label){
                        return json(['status'=>'success','msg'=>'更新成功']);
                    }else{
                        return json(['status'=>'fail','msg'=>'更新失败']);
                    }
                }else{
                    return json(['status'=>'fail','msg'=>'字段名称已经存在，不能重复添加！']);
                }
            }else{
                $label=Db::name('label')->where(['id'=>$data['id']])->save($data);
                return json(['status'=>'success','msg'=>'更新成功']);
            }
        }
        
    }

    public function click()
    {
        $data=input('post.');
        $click=Db::name('label')->where(['id'=>$data['id']])->update([$data['field']=>$data['value']]);
    }


    /**
     * 删除指定资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function delete($id)
    {
        $res = Db::name('label')->where('id',$id)->delete();
        if($res){
        	return json(['status'=>'success','msg'=>'删除成功']);
        }else{
        	return json(['status'=>'fail','msg'=>'删除失败']);
        }
    }
    
    public function del()
    {
        $data=input('post.');
        $del= Db::name('label')->where(['id'=>$data['id']])->delete();
        if($del){
        	return json(['status'=>'success','msg'=>'批量删除成功']);
        }else{
        	return json(['status'=>'fail','msg'=>'批量删除失败']);
        }
    }

}
