<?php
declare (strict_types = 1);

namespace app\admin\controller;

use think\Request;
use think\facade\View;
use think\facade\Db;

class System extends Common
{
    /**
     * 显示资源列表
     *
     * @return \think\Response
     */
    public function index()
    {
        if($data=input('post.')){

            // 获取数据库中的原始数据
            $originalData = Db::name('system')->where('id',1)->find();

            // 比较数据是否有变化
            $hasChanges = false;
            foreach ($data as $key => $value) {
                if (isset($originalData[$key]) && $originalData[$key] != $value) {
                    $hasChanges = true;
                    break;
                }
            }
            
            if (!$hasChanges) {
                return json(['status' => 'fail', 'msg' => '没有做任何修改']);
            }

            $system=Db::name('system')->where('id',1)->strict(false)->save($data);
            if($system){
                return json(['msg'=>'更新成功','status'=>'success']);
            }else{
                return json(['msg'=>'更新失败','status'=>'fail']);
            }
        }
        $system=Db::name('system')->where('id',1)->find();
        View::assign([
            'system'=>$system,
        ]);
        return View::fetch('index');
    }

    /**
     * 显示创建资源表单页.
     *
     * @return \think\Response
     */
    public function create()
    {
        //
    }

    /**
     * 保存新建的资源
     *
     * @param  \think\Request  $request
     * @return \think\Response
     */
    public function save(Request $request)
    {
       //
    }

    /**
     * 显示指定的资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function read($id)
    {
        //
    }

    /**
     * 显示编辑资源表单页.
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * 保存更新的资源
     *
     * @param  \think\Request  $request
     * @param  int  $id
     * @return \think\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * 删除指定资源
     *
     * @param  int  $id
     * @return \think\Response
     */
    public function delete($id)
    {
        //
    }
}
